﻿Imports Microsoft.Xna.Framework.Media

Partial Public Class MainPage
    Inherits PhoneApplicationPage
    ' Constructor
    Public Sub New()
        InitializeComponent()

        ' Set fields of appbar buttons; otherwise they're null
        playButton = TryCast(Me.ApplicationBar.Buttons(0), ApplicationBarIconButton)
        pauseButton = TryCast(Me.ApplicationBar.Buttons(1), ApplicationBarIconButton)

        ' Set MediaPlayer event
        AddHandler MediaPlayer.MediaStateChanged, AddressOf OnMediaPlayerStateChanged

        ' Update the elapsed time and slider position
        AddHandler CompositionTarget.Rendering, Sub(sender, args)
                                                    elapsedTime.Text = MediaPlayer.PlayPosition.ToString("m\:ss\.f")
                                                    mediaState.Text = MediaPlayer.State.ToString
                                                End Sub
    End Sub

    Private Sub OnRadioButtonChecked(ByVal sender As Object, ByVal args As RoutedEventArgs)
        Dim radio As RadioButton = TryCast(sender, RadioButton)
        Dim uriString As String = TryCast(radio.Tag, String)
        Dim uri As New Uri(uriString, If(uriString.Contains(":"c), UriKind.Absolute, UriKind.Relative))
        Dim song As Song = song.FromUri("song", uri)
        MediaPlayer.Play(song)
    End Sub

    Private Sub OnMediaPlayerStateChanged(ByVal sender As Object, ByVal args As EventArgs)
        Select Case MediaPlayer.State
            Case Microsoft.Xna.Framework.Media.MediaState.Playing
                playButton.IsEnabled = False
                pauseButton.IsEnabled = True

            Case Microsoft.Xna.Framework.Media.MediaState.Paused, Microsoft.Xna.Framework.Media.MediaState.Stopped
                playButton.IsEnabled = True
                pauseButton.IsEnabled = False

            Case Else
                playButton.IsEnabled = False
                pauseButton.IsEnabled = False
        End Select
    End Sub

    Private Sub OnPlayButtonClick(ByVal sender As Object, ByVal args As EventArgs)
        MediaPlayer.Resume()
    End Sub

    Private Sub OnPauseButtonClick(ByVal sender As Object, ByVal args As EventArgs)
        MediaPlayer.Pause()
    End Sub
End Class
