﻿Imports System.Windows.Threading
Imports Microsoft.Xna.Framework.Media

Partial Public Class MainPage
    Inherits PhoneApplicationPage
    Private random As New Random

    ' Constructor
    Public Sub New()
        InitializeComponent()

        Dim tmr As DispatcherTimer = New DispatcherTimer With {.Interval = TimeSpan.FromSeconds(0.1)}
        AddHandler tmr.Tick, Sub(sender, args)
                                 albumName.Inlines.Clear()
                                 artistName.Inlines.Clear()
                                 songName.Inlines.Clear()
                                 songArtistName.Inlines.Clear()

                                 Dim song As Song = MediaPlayer.Queue.ActiveSong

                                 If song IsNot Nothing Then
                                     albumName.Inlines.Add(New Run With {.Text = "Album: ", .FontWeight = FontWeights.Bold})
                                     albumName.Inlines.Add(New Run With {.Text = song.Album.Name})
                                     artistName.Inlines.Add(New Run With {.Text = "Album Artist: ", .FontWeight = FontWeights.Bold})
                                     artistName.Inlines.Add(New Run With {.Text = song.Album.Artist.Name})
                                     songName.Inlines.Add(New Run With {.Text = "Song: ", .FontWeight = FontWeights.Bold})
                                     songName.Inlines.Add(New Run With {.Text = song.Name})
                                     songArtistName.Inlines.Add(New Run With {.Text = "Song Artist: ", .FontWeight = FontWeights.Bold})
                                     songArtistName.Inlines.Add(New Run With {.Text = song.Artist.Name})
                                 End If
                             End Sub
        tmr.Start()
    End Sub

    Private Sub OnButtonClick(ByVal sender As Object, ByVal args As RoutedEventArgs)
        Dim mediaLib As New MediaLibrary
        Dim albums As AlbumCollection = mediaLib.Albums
        Dim album As Album = albums(random.Next(albums.Count))
        Dim songs As SongCollection = mediaLib.Songs
        Dim song As Song = songs(random.Next(songs.Count))
        MediaPlayer.Play(song)
    End Sub
End Class
